package com.baofoo.Demo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

import com.baofoo.rsa.RsaCodingUtil;
import com.baofoo.util.HttpUtil;
import com.baofoo.util.Log;
import com.baofoo.util.SecurityUtil;

/**
 * DEMO只做接口调试，实际对接以具体业务对接为准
 * 打款接口
 * @author mucang
 *
 */
public class T_1001_008_01 {
	public static void main(String[] args) throws Exception {
		String transNo = "TNO" + System.currentTimeMillis();// 商户订单号
		String transAccNo = "6228480444455553333";//收款人账号
		String transAccName = "测试";// 收款人名称
		// ----银行信息------------------
		// 付款类型是银行时必须填写银行信息,银行信息可选择填写联行号或省，市，支行名称两者其中一个
		String cardBankName = "农业银行";// 收款人银行名称
		String cardProName = "";// 银行卡收款人开户行省名
		String cardCityName = "";// 银行卡收款人开户行市名
		String cardAccDept = "";// 银行卡收款人开户行机构名
		String cardCnap = "";// 银行卡联行号
		// ----银行信息------------------
		String transIdCard = "320301198502169142";// 银行卡身份验证信息
		String transMobile = "";// 银行卡预留手机号验证信息
		String transSummary = "";

		String pfxpath = "C:\\Users\\mucang\\Downloads\\bfkey_100026681@@200001859.pfx";// 商户私钥
		String pfxpwd = "100026681_987537";// 私钥 密码
		String cerpath = "C:\\Users\\mucang\\Downloads\\bfkey_100026681@@200001859.cer";// 宝付公钥
		String memberId = "100026681";
		String terminalId = "200001859";
		String serviceTp = "T-1001-008-01";

		/* Header 参数 */
		Map<String, String> HeaderData = new HashMap<String, String>();
		HeaderData.put("memberId", memberId);// 宝付提供给商户的唯一编号
		HeaderData.put("terminalId", terminalId);
		HeaderData.put("serviceTp", serviceTp);//
		HeaderData.put("verifyType", "1");// 加密方式目前只有1种，请填：1

		Map<String, Object> BodyData = new TreeMap<String, Object>();
		List<Map> list = new ArrayList<Map>();
		Map<String, String> transContent1 = new TreeMap<String, String>();
		transContent1.put("transNo", transNo);
		transContent1.put("transAccNo", transAccNo);
		transContent1.put("transAccName", transAccName);
		transContent1.put("cardBankName", cardBankName);
		transContent1.put("cardProName", cardProName);
		transContent1.put("cardCityName", cardCityName);
		transContent1.put("cardAccDept", cardAccDept);
		transContent1.put("cardCnap", cardCnap);
		transContent1.put("transIdCard", transIdCard);
		transContent1.put("transMobile", transMobile);
		transContent1.put("transSummary", transSummary);
		list.add(transContent1);
		JSONArray jsonArr = JSONArray.fromObject(list);
		BodyData.put("transContent", jsonArr);

		Map<String, Object> contentData = new TreeMap<String, Object>();
		contentData.put("header", HeaderData);
		contentData.put("body", BodyData);

		JSONObject jsonObjectFromMap = JSONObject.fromObject(contentData);
		String Jsonstr = jsonObjectFromMap.toString();
		Log.Write("序列化：" + Jsonstr);

		String base64str = SecurityUtil.Base64Encode(Jsonstr);
		String data_content = RsaCodingUtil.encryptByPriPfxFile(base64str,
				pfxpath, pfxpwd);

		HeaderData.put("content", data_content);

		String PostString = HttpUtil.RequestForm(
				"https://vgw.baofoo.com/union-gw/api/"
						+ HeaderData.get("serviceTp") + "/transReq.do",
				HeaderData);
		Log.Write("请求返回：" + PostString);
		PostString = RsaCodingUtil.decryptByPubCerFile(PostString, cerpath);
		if (PostString.isEmpty()) {// 判断解密是否正确。如果为空则宝付公钥不正确
			Log.Write("=====检查解密公钥是否正确！");
			throw new Exception("Decryption is incorrect!");
		}
		PostString = SecurityUtil.Base64Decode(PostString);
		Log.Write("=====返回查询数据解密结果:" + PostString);
		JSONObject json = JSONObject.fromObject(PostString);
		JSONObject header = JSONObject.fromObject(json.get("header"));// 获取header
		Log.Write("sysRespCode:" + header.getString("sysRespCode"));
		if ("S_0000".equals(header.getString("sysRespCode"))) {
			JSONObject body = JSONObject.fromObject(json.get("body"));// 获取body
			JSONObject transHeader = JSONObject.fromObject(body
					.get("transHeader"));
			Log.Write("returnCode=" + transHeader.getString("returnCode")
					+ ",returnMsg=" + transHeader.getString("returnMsg"));
		}

	}
}
